package org.jboss.cache.api.mvcc;

import org.jboss.cache.Cache;
import org.jboss.cache.Fqn;
import org.jboss.cache.buddyreplication.BuddyReplicationTestsBase;
import org.jboss.cache.util.TestingUtil;
import org.testng.annotations.Test;

@Test(groups = {"functional", "mvcc"}, testName = "api.mvcc.BuddyReplicationConcurrencyTest")
public class BuddyReplicationConcurrencyTest extends BuddyReplicationTestsBase
{
   public static final Fqn f = Fqn.fromString("/a/b/c");
   public static final String k = "k";
   public static final String v = "v";

   public void testConcurrency() throws Exception
   {
      Cache<Object, Object> cache1 = null, cache2 = null;

      try
      {
         cache1 = createCache(1, null, true, true);
         cache2 = createCache(1, null, true, true);

         TestingUtil.blockUntilViewsReceived(60000, cache1, cache2);

         // put stuff in cache 1.  And ensure they exist in cache 2.

         for (int i = 0; i < 10; i++)
         {
            cache1.put(Fqn.fromRelativeElements(f, i), k, v);
            assert v.equals(cache1.get(Fqn.fromRelativeElements(f, i), k));
            assert v.equals(cache2.get(Fqn.fromRelativeElements(f, i), k));
         }
      }
      finally
      {
         TestingUtil.killCaches(cache1, cache2);
      }
   }
}
