/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package org.jboss.cache.util;

import java.io.FileOutputStream;
import java.io.PrintStream;
import org.jboss.cache.UnitTestCacheFactory;
import org.testng.IClass;
import org.testng.ITestContext;
import org.testng.ITestListener;
import org.testng.ITestResult;

/**
 *
 * @author dpospisi
 */
public class UnitTestTestNGListener implements ITestListener {
      
   /**
    * Holds test classes actually running in all threads.
    */
   private ThreadLocal<IClass> threadTestClass = new ThreadLocal<IClass>();
   
   private int failed = 0;
   private int succeded = 0;
   private int skipped = 0;
   
   public void onTestStart(ITestResult res) {
      System.out.println(getThreadId() + " Starting test " + getTestDesc(res));            
      
      /*
      IClass testClass = threadTestClass.get();
      if ((testClass != null) && (! res.getTestClass().equals(testClass))) {

         System.out.println(getThreadId() + " New test class" + res.getTestClass() + ", was " + testClass);            

         // the thread has started testing a new test class

         // clean all possibly running caches created in current thread
         boolean cleaned = new UnitTestCacheFactory().cleanUp();
         if (cleaned) {
            // previous test left a cache
            System.out.println(getThreadId() +" WARNING !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
            System.out.println(getThreadId() +" A test method in " + testClass.getName() + " did not clean all cache instances properly.");
            System.out.println(getThreadId() +" Use UnitTestCacheFactory.cleanUp() or TestngUtil.killCaches(...) ");
            System.out.println(getThreadId() +" WARNING !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!");
         }
      }
      */ 
      
      threadTestClass.set(res.getTestClass());
   }

   synchronized public void onTestSuccess(ITestResult arg0) {
      System.out.println(getThreadId() + " Test " + getTestDesc(arg0) + " succeded.");
      succeded++;
      printStatus();
   }

   synchronized public void onTestFailure(ITestResult arg0) {
      System.out.println(getThreadId() + " Test " + getTestDesc(arg0) + " failed.");
      failed++;
      printStatus();      
   }

   synchronized public void onTestSkipped(ITestResult arg0) {
      System.out.println(getThreadId() + " Test " + getTestDesc(arg0) + " skipped.");
      skipped++;
      printStatus();
   }

   public void onTestFailedButWithinSuccessPercentage(ITestResult arg0) {
   }

   public void onStart(ITestContext arg0) {      
   }

   public void onFinish(ITestContext arg0) {
   }
   
   private String getThreadId() {
       return  "["+ Thread.currentThread().getName() + "]";
   }
   
   private String getTestDesc(ITestResult res) {
      return res.getMethod().getMethodName() + "(" + res.getTestClass().getName() + ")";
   }
   
   private void printStatus() {
      System.out.println("Testsuite execution progress: tests succeded " + succeded + ", failed " + failed + ", skipped " + skipped + ".");
   }

}
